'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _Symbol = require('babel-runtime/core-js/symbol')['default'];

var _Set = require('babel-runtime/core-js/set')['default'];

var _regeneratorRuntime = require('babel-runtime/regenerator')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _dispatcher = require('./dispatcher');

var _dispatcher2 = _interopRequireDefault(_dispatcher);

var _componentEmitter = require('component-emitter');

var _componentEmitter2 = _interopRequireDefault(_componentEmitter);

var _errors = require('./errors');

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _Dispatcher = _Symbol();
var _Init = _Symbol();
var _Stores = _Symbol();
var _Title = _Symbol();
var _Locale = _Symbol();
var _AcceptLanguage = _Symbol();
var _LocaleMapping = _Symbol();
var _StoreData = _Symbol();
var _Files = _Symbol();
var _InitialData = _Symbol();

var ApplicationContext = (function () {
  function ApplicationContext(_ref) {
    var initialData = _ref.initialData;
    var _ref$locale = _ref.locale;
    var locale = _ref$locale === undefined ? 'en_US' : _ref$locale;
    var _ref$acceptLanguage = _ref.acceptLanguage;
    var acceptLanguage = _ref$acceptLanguage === undefined ? [] : _ref$acceptLanguage;
    var _ref$localeMapping = _ref.localeMapping;
    var localeMapping = _ref$localeMapping === undefined ? {} : _ref$localeMapping;
    var _ref$storeData = _ref.storeData;
    var storeData = _ref$storeData === undefined ? [] : _ref$storeData;

    _classCallCheck(this, ApplicationContext);

    this[_Dispatcher] = _dispatcher2['default'].getInstance(this);
    this[_Title] = [];
    this[_Stores] = new _Set();
    this[_Init] = false;
    this[_Locale] = locale;
    this[_AcceptLanguage] = acceptLanguage;
    this[_LocaleMapping] = localeMapping;
    this[_StoreData] = storeData.reverse();
    this[_Files] = new _Set();
    this[_InitialData] = initialData;
  }

  _createClass(ApplicationContext, [{
    key: 'runAction',
    value: function runAction(action) {
      return _regeneratorRuntime.async(function runAction$(context$2$0) {
        while (1) switch (context$2$0.prev = context$2$0.next) {
          case 0:
            action.ctx = this;
            context$2$0.prev = 1;
            context$2$0.t0 = this[_Dispatcher];
            context$2$0.t1 = action.constructor;
            context$2$0.next = 6;
            return _regeneratorRuntime.awrap(action.action(action.payload));

          case 6:
            context$2$0.t2 = context$2$0.sent;
            context$2$0.t3 = {
              action: context$2$0.t1,
              payload: context$2$0.t2
            };
            context$2$0.t0.dispatch.call(context$2$0.t0, context$2$0.t3);
            context$2$0.next = 16;
            break;

          case 11:
            context$2$0.prev = 11;
            context$2$0.t4 = context$2$0['catch'](1);

            context$2$0.t4 = new _errors.ActionError(context$2$0.t4);
            this.emit('error', context$2$0.t4);
            throw context$2$0.t4;

          case 16:
          case 'end':
            return context$2$0.stop();
        }
      }, null, this, [[1, 11]]);
    }
  }, {
    key: 'getStore',
    value: function getStore(Store) {
      return Store.getInstance(this);
    }
  }, {
    key: 'pushTitle',
    value: function pushTitle(title) {
      this[_Title].push(title);
    }
  }, {
    key: 'popTitle',
    value: function popTitle() {
      return this[_Title].pop();
    }
  }, {
    key: 'title',
    get: function get() {
      return this[_Title].slice().pop();
    }
  }, {
    key: 'stores',
    get: function get() {
      return this[_Stores];
    }
  }, {
    key: 'locale',
    get: function get() {
      return this[_Locale];
    },
    set: function set(locale) {
      this[_Locale] = locale;
    }
  }, {
    key: 'acceptLanguage',
    get: function get() {
      return this[_AcceptLanguage];
    }
  }, {
    key: 'localeMapping',
    get: function get() {
      return this[_LocaleMapping];
    }
  }, {
    key: 'init',
    get: function get() {
      return this[_Init];
    },
    set: function set(init) {
      this[_Init] = !!init;
    }
  }, {
    key: 'storeData',
    get: function get() {
      if (this[_StoreData].length > 0) {
        return this[_StoreData].pop();
      }
    }
  }, {
    key: 'files',
    get: function get() {
      return this[_Files];
    }
  }, {
    key: 'initialData',
    get: function get() {
      return this[_InitialData];
    }
  }]);

  return ApplicationContext;
})();

exports['default'] = ApplicationContext;

(0, _componentEmitter2['default'])(ApplicationContext.prototype);

//    export default class AppContext {
//      constructor() {
//        this[ACCEPTLANG] = [];
//        this[_LocaleMAPPING] = {};
//
//      }
//      get files() {
//        return this[FILES];
//      }
//    }
//
//    Emitter(AppContext.prototype);
//
//    Object.defineProperty(AppContext.prototype, STATE, {
//      get() {
//        return {
//          locale: this[_Locale],
//          acceptLanguage: this[ACCEPTLANG],
//          mapping: this[_LocaleMAPPING]
//        };
//      },
//      set(val) {
//        this[_Locale] = val.locale;
//        this[ACCEPTLANG] = val.acceptLanguage;
//        this[_LocaleMAPPING] = val.mapping;
//      }
//    });
module.exports = exports['default'];
//# sourceMappingURL=application-context.js.map
