'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _Symbol = require('babel-runtime/core-js/symbol')['default'];

var _Object$defineProperties = require('babel-runtime/core-js/object/define-properties')['default'];

var _regeneratorRuntime = require('babel-runtime/regenerator')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouter = require('react-router');

var _component = require('./component');

var _component2 = _interopRequireDefault(_component);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _greaseboxAsyncMap = require('greasebox/async-map');

var _greaseboxAsyncMap2 = _interopRequireDefault(_greaseboxAsyncMap);

var _locale = require('./locale');

var _locale2 = _interopRequireDefault(_locale);

var _errors = require('./errors');

var isClient = typeof window !== 'undefined';

var _ChildRoutes = _Symbol();
var _Component = _Symbol();
var _LoadingComponent = _Symbol();
var _ComponentPath = _Symbol();
var _Locale = _Symbol();
var _Ctx = _Symbol();
var _CtxObject = _Symbol();
var _Routes = _Symbol();
var _LoadingRoutes = _Symbol();
var _RouteObject = _Symbol();

var Application = (function () {
  function Application(ctx) {
    var _this = this;

    _classCallCheck(this, Application);

    this[_Ctx] = ctx;
    //this[_ChildRoutes] = this.childRoutes.map(r => path.resolve(normalizeDirname(this.dirname), r));
    this[_ChildRoutes] = this.childRoutes.map(function (r) {
      return normalizedResolver(_this.dirname, r);
    });
    //this[_ComponentPath] = path.resolve(normalizeDirname(this.dirname), this.component);
    this[_ComponentPath] = normalizedResolver(this.dirname, this.component);
    this[_Locale] = new _locale2['default'](ctx, processLocaleSetting.call(this));
    this[_CtxObject] = _Object$defineProperties({
      context: {
        ctx: ctx,
        locale: this[_Locale]
      },
      runAction: function runAction(action) {
        return this.context.ctx.runAction(action);
      },
      getStore: function getStore(Store) {
        return Store.getInstance(this.context.ctx);
      },

      setLocale: function setLocale(l) {
        return this.context.locale.setLocale(l);
      },
      tmpl: function tmpl(key, params) {
        return this.context.locale(key, params);
      },
      formatNumber: function formatNumber() {
        var _context$locale;

        return (_context$locale = this.context.locale).formatNumber.apply(_context$locale, arguments);
      },
      formatCurrency: function formatCurrency() {
        var _context$locale2;

        return (_context$locale2 = this.context.locale).formatCurrency.apply(_context$locale2, arguments);
      },
      formatDateTime: function formatDateTime() {
        var _context$locale3;

        return (_context$locale3 = this.context.locale).formatDateTime.apply(_context$locale3, arguments);
      }
    }, {
      locale: {
        get: function get() {
          return this.context.locale.locale;
        },
        configurable: true,
        enumerable: true
      }
    });
  }

  _createClass(Application, [{
    key: 'title',
    value: function title() {
      return void 0;
    }
  }, {
    key: 'onEnter',
    value: function onEnter() {
      return _regeneratorRuntime.async(function onEnter$(context$2$0) {
        while (1) switch (context$2$0.prev = context$2$0.next) {
          case 0:
          case 'end':
            return context$2$0.stop();
        }
      }, null, this);
    }
  }, {
    key: 'onLeave',

    //overload this function to define onEnter hook handlers
    value: function onLeave() {
      //overload this function to define onLeave hook handlers
    }
  }, {
    key: 'routerWillLeave',
    value: function routerWillLeave(nextLocation) {
      //overload this function to define routerWillLeave lifecycle method.
      //this allow leave confirmations to be done.
    }
  }, {
    key: 'path',
    get: function get() {
      return void 0;
    }
  }, {
    key: 'childRoutes',
    get: function get() {
      return [];
    }
  }, {
    key: 'component',
    get: function get() {
      throw new Error('Application must define a relative path to component');
      return void 0;
    }
  }, {
    key: 'dirname',
    get: function get() {
      throw new Error('Application must define dirname');
    }
  }, {
    key: 'locale',
    get: function get() {
      return void 0;
    }
  }, {
    key: 'stores',
    get: function get() {
      return [];
    }
  }, {
    key: 'routes',
    get: function get() {
      var _this2 = this;

      if (!this[_RouteObject]) {
        this[_RouteObject] = {
          path: this.path,
          getChildRoutes: function getChildRoutes(location, cb) {
            if (_this2[_Routes]) {
              cb(null, _this2[_Routes]);
            } else if (_this2[_LoadingRoutes]) {
              (function callee$3$0() {
                return _regeneratorRuntime.async(function callee$3$0$(context$4$0) {
                  while (1) switch (context$4$0.prev = context$4$0.next) {
                    case 0:
                      context$4$0.next = 2;
                      return _regeneratorRuntime.awrap(this[_LoadingRoutes]);

                    case 2:
                      cb(null, this[_Routes]);

                    case 3:
                    case 'end':
                      return context$4$0.stop();
                  }
                }, null, _this2);
              })();
            } else {
              _this2[_LoadingRoutes] = (function callee$3$0() {
                var childRoutes;
                return _regeneratorRuntime.async(function callee$3$0$(context$4$0) {
                  var _this3 = this;

                  while (1) switch (context$4$0.prev = context$4$0.next) {
                    case 0:
                      childRoutes = [];

                      if (!isClient) {
                        context$4$0.next = 7;
                        break;
                      }

                      context$4$0.next = 4;
                      return _regeneratorRuntime.awrap((0, _greaseboxAsyncMap2['default'])(this[_ChildRoutes], function callee$4$0(r) {
                        var ChildApp, child;
                        return _regeneratorRuntime.async(function callee$4$0$(context$5$0) {
                          while (1) switch (context$5$0.prev = context$5$0.next) {
                            case 0:
                              context$5$0.prev = 0;
                              context$5$0.next = 3;
                              return _regeneratorRuntime.awrap(System['import'](r));

                            case 3:
                              ChildApp = context$5$0.sent;
                              child = new ChildApp(this[_Ctx]);
                              return context$5$0.abrupt('return', child.routes);

                            case 8:
                              context$5$0.prev = 8;
                              context$5$0.t0 = context$5$0['catch'](0);

                              this[_Ctx].emit('error', context$5$0.t0);

                            case 11:
                            case 'end':
                              return context$5$0.stop();
                          }
                        }, null, _this3, [[0, 8]]);
                      }));

                    case 4:
                      childRoutes = context$4$0.sent;
                      context$4$0.next = 8;
                      break;

                    case 7:
                      childRoutes = this[_ChildRoutes].map(function (r) {
                        try {
                          var ChildApp = require(r);
                          var child = new ChildApp(_this3[_Ctx]);
                          _this3[_Ctx].files.add(r);
                          return child.routes;
                        } catch (err) {
                          _this3[_Ctx].emit('error', err);
                        }
                      });

                    case 8:
                      this[_Routes] = childRoutes.filter(function (r) {
                        return !!r;
                      });
                      cb(null, this[_Routes]);

                    case 10:
                    case 'end':
                      return context$4$0.stop();
                  }
                }, null, _this2);
              })();
            }
          },
          onEnter: function onEnter(nextState, replaceState, cb) {
            var _context, title, _context2;

            return _regeneratorRuntime.async(function onEnter$(context$3$0) {
              var _this4 = this;

              while (1) switch (context$3$0.prev = context$3$0.next) {
                case 0:
                  context$3$0.prev = 0;
                  context$3$0.next = 3;
                  return _regeneratorRuntime.awrap(this[_Locale].loadLocales());

                case 3:
                  context$3$0.next = 9;
                  break;

                case 5:
                  context$3$0.prev = 5;
                  context$3$0.t0 = context$3$0['catch'](0);

                  if (!(context$3$0.t0 instanceof _errors.LocaleLoadError)) {
                    context$3$0.t0 = new _errors.LocaleLoadError(context$3$0.t0);
                  }
                  this[_Ctx].emit('error', context$3$0.t0);

                case 9:

                  //stores
                  this.stores.forEach(function (s) {
                    var store = s.getInstance(_this4[_Ctx]);
                    return store;
                  });

                  //title
                  if (this.title !== Application.prototype.title) {
                    try {
                      title = (_context = this[_CtxObject], this.title).call(_context);

                      if (title) {
                        this[_Ctx].pushTitle(title);
                      }
                    } catch (err) {
                      this[_Ctx].emit('error', err);
                    }
                  }

                  if (!(this[_Ctx].init && this.onEnter !== Application.prototype.onEnter && typeof this.onEnter === 'function')) {
                    context$3$0.next = 23;
                    break;
                  }

                  context$3$0.prev = 12;
                  context$3$0.next = 15;
                  return _regeneratorRuntime.awrap((_context2 = this[_CtxObject], this.onEnter).call(_context2, nextState, replaceState));

                case 15:
                  cb();
                  context$3$0.next = 21;
                  break;

                case 18:
                  context$3$0.prev = 18;
                  context$3$0.t1 = context$3$0['catch'](12);

                  cb(context$3$0.t1);

                case 21:
                  context$3$0.next = 24;
                  break;

                case 23:
                  cb();

                case 24:
                case 'end':
                  return context$3$0.stop();
              }
            }, null, _this2, [[0, 5], [12, 18]]);
          },
          onLeave: function onLeave() {
            //title
            if (_this2.title !== Application.prototype.title) {
              try {
                var _context3;

                var title = (_context3 = _this2[_CtxObject], _this2.title).call(_context3);
                if (title) {
                  _this2[_Ctx].popTitle();
                }
              } catch (err) {
                _this2[_Ctx].emit('error', err);
              }
            }
            if (_this2.onLeave !== Application.prototype.onLeave && typeof _this2.onLeave === 'function') {
              var _context4;

              (_context4 = _this2[_CtxObject], _this2.onLeave).call(_context4);
            }
          },
          getComponent: function getComponent(location, cb) {
            var self = _this2;
            if (_this2[_Component]) {
              cb(null, _this2[_Component]);
            } else if (_this2[_LoadingComponent]) {
              (function callee$3$0() {
                return _regeneratorRuntime.async(function callee$3$0$(context$4$0) {
                  while (1) switch (context$4$0.prev = context$4$0.next) {
                    case 0:
                      context$4$0.next = 2;
                      return _regeneratorRuntime.awrap(this[_LoadingComponent]);

                    case 2:
                      cb(null, this[_Component]);

                    case 3:
                    case 'end':
                      return context$4$0.stop();
                  }
                }, null, _this2);
              })();
            } else {
              _this2[_LoadingComponent] = (function callee$3$0() {
                var Comp;
                return _regeneratorRuntime.async(function callee$3$0$(context$4$0) {
                  while (1) switch (context$4$0.prev = context$4$0.next) {
                    case 0:
                      Comp = undefined;

                      if (!isClient) {
                        context$4$0.next = 14;
                        break;
                      }

                      context$4$0.prev = 2;
                      context$4$0.next = 5;
                      return _regeneratorRuntime.awrap(System['import'](this[_ComponentPath]));

                    case 5:
                      Comp = context$4$0.sent;
                      context$4$0.next = 12;
                      break;

                    case 8:
                      context$4$0.prev = 8;
                      context$4$0.t0 = context$4$0['catch'](2);

                      this[_Ctx].emit('error', context$4$0.t0);
                      cb(context$4$0.t0);

                    case 12:
                      context$4$0.next = 16;
                      break;

                    case 14:
                      this[_Ctx].files.add(this[_ComponentPath]);
                      try {
                        Comp = require(this[_ComponentPath]);
                      } catch (err) {
                        this[_Ctx].emit('error', err);
                        cb(err);
                      }

                    case 16:

                      //extends the Comp with contexts
                      this[_Component] = (function (_Component2) {
                        _inherits(K, _Component2);

                        function K() {
                          _classCallCheck(this, K);

                          _get(Object.getPrototypeOf(K.prototype), 'constructor', this).apply(this, arguments);
                        }

                        _createClass(K, [{
                          key: 'componentDidMount',
                          value: function componentDidMount() {
                            if (this.routerWillLeave !== Application.prototype.routerWillLeave && typeof self.routerWillLeave === 'function') {
                              this._unlistenBeforeLeavingRoute = this.context.history.listenBefore(self.routerWillLeave.bind(this));
                            }
                          }
                        }, {
                          key: 'componentWillUnmount',
                          value: function componentWillUnmount() {
                            if (this._unlistenBeforeLeavingRoute) {
                              this._unlistenBeforeLeavingRoute();
                            }
                          }
                        }, {
                          key: 'getChildContext',
                          value: function getChildContext() {
                            return self[_CtxObject].context;
                          }
                        }, {
                          key: 'render',
                          value: function render() {
                            return _react2['default'].createElement(Comp, this.props);
                          }
                        }], [{
                          key: 'contextTypes',
                          get: function get() {
                            return {
                              ctx: _react.PropTypes.object,
                              locale: _react.PropTypes.func,
                              history: _reactRouter.PropTypes.history,
                              route: _reactRouter.PropTypes.route
                            };
                          }
                        }, {
                          key: 'childContextTypes',
                          get: function get() {
                            return {
                              ctx: _react.PropTypes.object,
                              locale: _react.PropTypes.func
                            };
                          }
                        }]);

                        return K;
                      })(_component2['default']);
                      cb(null, this[_Component]);

                    case 18:
                    case 'end':
                      return context$4$0.stop();
                  }
                }, null, _this2, [[2, 8]]);
              })();
            }
          }

        };
      }
      return this[_RouteObject];
    }
  }]);

  return Application;
})();

exports['default'] = Application;

function processLocaleSetting() {
  var settings = this.locale;
  if (settings) {
    //settings.path = path.resolve(normalizeDirname(this.dirname), settings.path);
    settings.path = normalizedResolver(this.dirname, settings.path);
  }
  return settings;
}

var httpCheck = /^http/;
var httpReplace = /^(http:\/\/.*?)(\/)/;

function normalizedResolver(dirname, p) {
  if (httpCheck.test(dirname)) {
    var match = dirname.match(httpReplace);
    dirname = dirname.replace(httpReplace, '/');
    return match[1] + _path2['default'].resolve(dirname, p);
  }
  return _path2['default'].resolve(dirname, p);
}
function normalizeDirname(dirname) {
  if (httpCheck.test(dirname)) {
    return dirname.replace(httpReplace, '');
  }
  return dirname;
}
module.exports = exports['default'];
//# sourceMappingURL=application.js.map
