'use strict';

var _taggedTemplateLiteral = require('babel-runtime/helpers/tagged-template-literal')['default'];

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = bootstrap;

var _templateObject = _taggedTemplateLiteral(['\n        (function () {\n          System.meepworks = {\n          appVersion: \'', '\',\n          jspmPath: \'', '\'\n          };\n\n          var fetch = System.fetch;\n          System.fetch = function (load) {\n            if(load.address.indexOf(System.meepworks.jspmPath) === -1) {\n              load.address += System.meepworks.appVersion;\n            }\n            var result = fetch.call(this, load);\n            return result;\n          };\n          System.import(\'meepworks/client-router\')\n          .then(function (ClientRouter) {\n            var router = new ClientRouter(\'', '\', \'', '\', ', ');\n          })\n          .catch(console.log);\n        })();'], ['\n        (function () {\n          System.meepworks = {\n          appVersion: \'', '\',\n          jspmPath: \'', '\'\n          };\n\n          var fetch = System.fetch;\n          System.fetch = function (load) {\n            if(load.address.indexOf(System.meepworks.jspmPath) === -1) {\n              load.address += System.meepworks.appVersion;\n            }\n            var result = fetch.call(this, load);\n            return result;\n          };\n          System.import(\'meepworks/client-router\')\n          .then(function (ClientRouter) {\n            var router = new ClientRouter(\'', '\', \'', '\', ', ');\n          })\n          .catch(console.log);\n        })();']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _uuid = require('uuid');

var _uuid2 = _interopRequireDefault(_uuid);

var _greaseboxDedent = require('greasebox/dedent');

var _greaseboxDedent2 = _interopRequireDefault(_greaseboxDedent);

var _htmlEscape = require('html-escape');

var _htmlEscape2 = _interopRequireDefault(_htmlEscape);

var _transitImmutableJs = require('transit-immutable-js');

var _transitImmutableJs2 = _interopRequireDefault(_transitImmutableJs);

/**
 *  @class Data
 *  @description Component for rendering data to be sent to client side.
 */

var Data = (function (_Component) {
  _inherits(Data, _Component);

  function Data() {
    _classCallCheck(this, Data);

    _get(Object.getPrototypeOf(Data.prototype), 'constructor', this).apply(this, arguments);
  }

  /**
   * @class Loader
   * @description Script that loads the framework and starts the application.
   */

  _createClass(Data, [{
    key: 'render',
    value: function render() {
      //convert data to base64 string avoid html injection
      var res = (0, _htmlEscape2['default'])(_transitImmutableJs2['default'].toJSON(this.props.data));
      return _react2['default'].createElement('script', {
        id: this.props.dataId,
        type: 'application/json',
        dangerouslySetInnerHTML: {
          __html: res
        }
      });
    }
  }]);

  return Data;
})(_react.Component);

var Loader = (function (_Component2) {
  _inherits(Loader, _Component2);

  function Loader() {
    _classCallCheck(this, Loader);

    _get(Object.getPrototypeOf(Loader.prototype), 'constructor', this).apply(this, arguments);
  }

  _createClass(Loader, [{
    key: 'render',
    value: function render() {
      return _react2['default'].createElement('script', { dangerouslySetInnerHTML: {
          __html: (0, _greaseboxDedent2['default'])(_templateObject, this.props.version, this.props.jspmPath, this.props.appUrl, this.props.dataId, this.props.clientRender)
        } });
    }
  }]);

  return Loader;
})(_react.Component);

function bootstrap(data) {

  var appUrl = this.appPath.replace(this.publicPath, this.publicUrl);
  var jsVer = this.version ? '?' + this.version : '';
  var output = [_react2['default'].createElement('script', { key: 'sys', src: '/' + this.jspmPath + '/system.js' + jsVer }), _react2['default'].createElement('script', { key: 'config', src: '/' + this.jspmConfig + jsVer })];
  var dataId = 'data-' + (0, _uuid2['default'])();
  output.push(_react2['default'].createElement(Data, { data: data, dataId: dataId }));
  output.push(_react2['default'].createElement(Loader, {
    dataId: dataId,
    version: jsVer,
    jspmPath: this.jspmPath,
    appUrl: appUrl,
    clientRender: this.clientRender
  }));

  return output;
}

/*
 *export default function bootstrap(target, data) {
 *  let jsVer = this.config.version ? `?${this.config.version}` : '';
 *  let output = [
 *    <script key="sys" src={ `/${this.config.jspm.path}/system.js${jsVer}` }></script>,
 *    <script key="config" src={ `/${this.config.jspm.config}${jsVer}` }></script>
 *  ];
 *  let dataId = 'data-'+ uuid();
 *  output.push(<Data data={data} dataId={dataId}/>);
 *  output.push(<Loader config={this.config} target={target} dataId={dataId} />);
 *  return output;
 *}
 */
module.exports = exports['default'];
//# sourceMappingURL=bootstrap.js.map
