'use strict';

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _extends = require('babel-runtime/helpers/extends')['default'];

var _regeneratorRuntime = require('babel-runtime/regenerator')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _reactRouter = require('react-router');

var _reactRouter2 = _interopRequireDefault(_reactRouter);

var _tmpl = require('./tmpl');

var _tmpl2 = _interopRequireDefault(_tmpl);

var _transitImmutableJs = require('transit-immutable-js');

var _transitImmutableJs2 = _interopRequireDefault(_transitImmutableJs);

var _historyLibCreateBrowserHistory = require('history/lib/createBrowserHistory');

var _historyLibCreateBrowserHistory2 = _interopRequireDefault(_historyLibCreateBrowserHistory);

var _applicationContext = require('./application-context');

var _applicationContext2 = _interopRequireDefault(_applicationContext);

var rAm = /&amp;/g;
var rLt = /&lt;/g;
var rGt = /&gt;/g;
var rAp = /&#39;/g;
var rQu = /&quot;/g;

function unescapeHTML(str) {
  return str.replace(rLt, '<').replace(rGt, '>').replace(rAp, "'").replace(rQu, '"').replace(rAm, '&');
}

var ClientRouter = function ClientRouter(appURL, dataId) {
  var _this = this;

  var init = arguments.length <= 2 || arguments[2] === undefined ? false : arguments[2];

  _classCallCheck(this, ClientRouter);

  (function callee$1$0() {
    var App, dataScript, data, ctx, routes;
    return _regeneratorRuntime.async(function callee$1$0$(context$2$0) {
      while (1) switch (context$2$0.prev = context$2$0.next) {
        case 0:
          context$2$0.next = 2;
          return _regeneratorRuntime.awrap(System['import'](appURL));

        case 2:
          App = context$2$0.sent;
          dataScript = document.querySelector('script[id="' + dataId + '"]');
          data = _transitImmutableJs2['default'].fromJSON(unescapeHTML(dataScript.innerHTML));
          ctx = new _applicationContext2['default'](data);

          if (init) {
            ctx.init = true;
          }

          routes = new App(ctx).routes;

          (0, _reactRouter.match)({ routes: routes, location: window.location }, function (error, redirectLocation, renderProps) {
            _reactDom2['default'].render(_react2['default'].createElement(_reactRouter2['default'], _extends({}, renderProps, {
              history: (0, _historyLibCreateBrowserHistory2['default'])(),
              onError: function (err) {
                ctx.emit('error', err);
              },
              onUpdate: function () {
                var title = ctx.title;
                if (title) {
                  title = _tmpl2['default'].format(title, this.state.params);
                  document.title = title;
                }
                ctx.init = true;
              }
            })), document.getElementById('viewport'));
          });

          /*
           *ReactDOM.render(
           *  <Router
           *    routes={routes}
           *    history={createBrowserHistory()}
           *    onError={(err) => {
           *      ctx.emit('error', err);
           *    }}
           *    onUpdate={function () {
           *      let title = ctx.title;
           *      if(title) {
           *        title = Tmpl.format(title, this.state.params);
           *        document.title = title;
           *      }
           *      ctx.init = true;
           *    }}
           *  />
           *, document.getElementById('viewport'));
           */

        case 9:
        case 'end':
          return context$2$0.stop();
      }
    }, null, _this);
  })();
}

/*
 *
 *export default class AppDriver {
 *  constructor(src, target, dataId) {
 *
 *
 *    let ctx = new AppContext();
 *    ctx[STATE] = data.context;
 *    driver.ctx = ctx;
 *
 *    let routes = (
 *      <Route handler={new AppLoader(AppRoot, ctx)}>
 *        {generateRoutes(driver.routeTable, ctx, data.baseURL)}
 *        <NotFoundRoute handler={NotFound} />
 *      </Route>
 *    );
 *
 *    let location = new Location(data.baseURL);
 *
 *    let r = Router.create({
 *      routes,
 *      location,
 *      onError: (err) => {
 *        debugger;
 *        ctx.emit('error', err);
 *      }
 *    });
 *    r.run((Root, state) => {
 *        //rehydrate stores
 *        if(ctx[APP_INIT]) {
 *          let title;
 *          if(ctx.title.length > 0) {
 *            title = ctx.title[ctx.title.length - 1](location.getCurrentPath());
 *          }
 *          if(title !== void 0) {
 *            title = Tmpl.format(title, state.params);
 *            document.title = title;
 *          }
 *        } else {
 *          ctx.stores.forEach(s => {
 *            s.rehydrate(data.stores.shift());
 *          });
 *          ctx[APP_INIT] = true;
 *        }
 *        React.render(<Root />, driver.target);
 *     });
 *
 *
 *  }
 *
 *}
 *
 *function traceRoutes(table, src) {
 *  if(!src) {
 *    src = this.appSrc;
 *  }
 *  table.appPath = src;
 *
 *  if(table.routes) {
 *    for(let p in table.routes) {
 *      if(table.routes[p].appPath) {
 *        this::traceRoutes(table.routes[p], url.resolve(src, table.routes[p].appPath));
 *      }
 *    }
 *  }
 *  return table;
 *}
 *
 *function generateRoutes(table, ctx, baseURL = '', currentPath = '') {
 *
 *  let children = [];
 *  if(table.routes) {
 *    for(let p in table.routes) {
 *      let handler = table.routes[p].appPath ?
 *        new AppLoader(
 *          table.routes[p].appPath,
 *          ctx,
 *          currentPath,
 *          baseURL
 *        ) :
 *        NullApp;
 *      if(p === '$default') {
 *        children.push(
 *          <DefaultRoute key={p} handler={handler}/>
 *        );
 *      } else if (p === '$notfound') {
 *        children.push(
 *          <NotFoundRoute key={p} handler={handler} />
 *        );
 *      } else {
 *        children.push(
 *          this::generateRoutes(
 *            table.routes[p],
 *            ctx,
 *            baseURL,
 *            currentPath === '' ? p : `${currentPath}/${p}`
 *          )
 *        );
 *      }
 *    }
 *  }
 *  let handler = table.appPath ?
 *    new AppLoader(table.appPath, ctx, currentPath, baseURL) :
 *    NullApp;
 *  return (
 *    <Route path={`/${currentPath}`} key={`/${currentPath}`} handler={handler}>
 *      {children}
 *    </Route>
 *  );
 *
 *}
 *
 */
;

exports['default'] = ClientRouter;
module.exports = exports['default'];
//# sourceMappingURL=client-router.js.map
