'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _Symbol = require('babel-runtime/core-js/symbol')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _flux = require('flux');

var _flux2 = _interopRequireDefault(_flux);

var _instance = require('./instance');

var _instance2 = _interopRequireDefault(_instance);

var _DispatchToken = _Symbol();
var _Dispatcher = _Symbol();
/**
 * @exports default
 * @class Dispatcher
 *    Wraps Flux.Dispatcher to provide instanced
 *    dispatcher.
 */

var Dispatcher = (function (_Instance) {
  _inherits(Dispatcher, _Instance);

  function Dispatcher() {
    _classCallCheck(this, Dispatcher);

    _get(Object.getPrototypeOf(Dispatcher.prototype), 'constructor', this).call(this);
    this[_Dispatcher] = new _flux2['default'].Dispatcher();
  }

  /**
   * @function
   * @param {StoreBase} store - store to be registered
   */

  _createClass(Dispatcher, [{
    key: 'register',
    value: function register(store, fn) {
      store[_DispatchToken] = this[_Dispatcher].register(fn);
    }

    /**
     *  @function
     *  @param {StoreBase} store - store to be unregistered
     */
  }, {
    key: 'unregister',
    value: function unregister(store) {
      this[_Dispatcher].unregister(store[_DispatchToken]);
    }

    /**
     *  @function
     *  @param {Array<StoreBase>} stores - array of stores to wait for.
     */
  }, {
    key: 'waitFor',
    value: function waitFor(stores) {
      if (!Array.isArray(stores)) {
        stores = [stores];
      }
      this[_Dispatcher].waitFor(stores.map(function (s) {
        return s[_DispatchToken];
      }));
    }
  }, {
    key: 'dispatch',
    value: function dispatch(payload) {
      this[_Dispatcher].dispatch(payload);
    }
  }, {
    key: 'isDispatching',
    value: function isDispatching() {
      return this[_Dispatcher].isDispatching();
    }
  }]);

  return Dispatcher;
})(_instance2['default']);

exports['default'] = Dispatcher;
module.exports = exports['default'];
//# sourceMappingURL=dispatcher.js.map
