'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDomServer = require('react-dom/server');

var _viewport = require('./viewport');

var _viewport2 = _interopRequireDefault(_viewport);

/**
 *  @class HtmlPage
 *  @description Default Server Html Templates
 *  @property script {Array} Array of script elements to be rendered
 *  @property styles {Array} Array of stylesheet link elements to be rendered
 *  @property metas {Array} Array of meta elements to be rendered
 *  @property title {string} Title for the html page
 *  @property body {Component} Elements to be rendered in body tag
 *  @property innerHTML {string} Html string to be rendered. Will ignore body property if provided.
 *
 */

var HtmlPage = (function (_React$Component) {
  _inherits(HtmlPage, _React$Component);

  function HtmlPage() {
    _classCallCheck(this, HtmlPage);

    _get(Object.getPrototypeOf(HtmlPage.prototype), 'constructor', this).apply(this, arguments);
  }

  _createClass(HtmlPage, [{
    key: 'render',
    value: function render() {
      return _react2['default'].createElement(
        'html',
        null,
        _react2['default'].createElement(
          'head',
          null,
          _react2['default'].createElement('meta', { name: 'viewport', content: 'width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no' }),
          _react2['default'].createElement('meta', { httpEquiv: 'Content-Type', content: 'text/html; charset=utf-8' }),
          this.props.metas,
          _react2['default'].createElement(
            'title',
            null,
            this.props.title
          ),
          this.props.styles,
          this.props.scripts
        ),
        _react2['default'].createElement(
          'body',
          null,
          _react2['default'].createElement(
            _viewport2['default'],
            null,
            this.props.children
          )
        )
      );
    }
  }], [{
    key: 'defaultProps',
    get: function get() {
      return {
        scripts: [],
        styles: [],
        metas: [],
        title: null
      };
    }
  }]);

  return HtmlPage;
})(_react2['default'].Component);

exports['default'] = HtmlPage;
module.exports = exports['default'];
//# sourceMappingURL=html-page.js.map
