"use strict";

var _createClass = require("babel-runtime/helpers/create-class")["default"];

var _classCallCheck = require("babel-runtime/helpers/class-call-check")["default"];

var _WeakMap = require("babel-runtime/core-js/weak-map")["default"];

var _Symbol = require("babel-runtime/core-js/symbol")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _cache = new _WeakMap();
/**
 * Use weak maps for instances so that instances can easily be gc'ed
 * if the key is the request object itself.
 *
 */

var _Ctx = _Symbol();
/**
 * @class Instance
 *  simple implementation of instanced objects
 */

var Instance = (function () {
  function Instance() {
    _classCallCheck(this, Instance);
  }

  _createClass(Instance, [{
    key: "destroy",

    /**
     * @function
     *
     * Remove the singleton from the internal cache.
     */
    value: function destroy() {
      var cache = _cache.get(this.constructor);
      if (this[_Ctx]) {
        //use key to clear _cache
        if (cache.has(this[_Ctx])) {
          cache["delete"](this[_Ctx]);
        }
      } else {
        if (cache.has(this.constructor)) {
          cache["delete"](this.constructor);
        }
      }
    }
  }, {
    key: "ctx",
    get: function get() {
      return this[_Ctx];
    }
  }], [{
    key: "getInstance",

    /**
     * @function
     * @param {object} key - optional object to use as a key
     *  Symbol value does not work on IE.
     *
     * Function getInstance returns the singleton if no key is passed in.
     * If an object is passed in as the key, it returns an unique instance
     * identified only by the object. If the object key is gc'ed, the unique
     * instance will be gc'ed as well. Unless it is being held by another
     * reference.
     */
    value: function getInstance(key) {
      if (!_cache.has(this)) {
        _cache.set(this, new _WeakMap());
      }
      var cache = _cache.get(this);

      if (key) {
        if (!cache.has(key)) {
          var inst = new this();

          cache.set(key, inst);
          //keep a reference to the key for destroy
          inst[_Ctx] = key;
        }
        return cache.get(key);
      } else {
        if (!cache.has(this)) {
          var inst = new this();
          cache.set(this, inst);
        }
        return cache.get(this);
      }
    }
  }]);

  return Instance;
})();

exports["default"] = Instance;
module.exports = exports["default"];
//# sourceMappingURL=instance.js.map
