'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _slicedToArray = require('babel-runtime/helpers/sliced-to-array')['default'];

var _Map = require('babel-runtime/core-js/map')['default'];

var _Symbol = require('babel-runtime/core-js/symbol')['default'];

var _Set = require('babel-runtime/core-js/set')['default'];

var _regeneratorRuntime = require('babel-runtime/regenerator')['default'];

var _getIterator = require('babel-runtime/core-js/get-iterator')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _intl = require('intl');

var _intl2 = _interopRequireDefault(_intl);

var _tmpl = require('./tmpl');

var _tmpl2 = _interopRequireDefault(_tmpl);

var _errors = require('./errors');

//const Intl = global.Intl || IntlPolyfill;
var Intl = _intl2['default'];
var Cache = new _Map();
var NumberFormatters = new _Map();
var DateFormatters = new _Map();

var _Ctx = _Symbol();
var _Path = _Symbol();

var localeDataLoaded = false;
var isClient = typeof window !== 'undefined';

var Locale = (function () {
  function Locale(ctx, setting) {
    _classCallCheck(this, Locale);

    //load files and create mappings
    var self = function self(key, params) {
      var p = self[_Path];
      if (!p) {
        return key;
      }
      var m = self[_Ctx].localeMapping[p];
      var res = Cache.get(self[_Path]).preload[m][key];
      if (typeof res === 'undefined') {
        return key;
      }

      if (typeof params !== 'undefined') {
        res = _tmpl2['default'].format(res, params);
      }
      return res;
    };

    self[_Ctx] = ctx;

    if (typeof setting !== 'undefined') {

      self[_Path] = setting.path;
      if (!setting.preload) {
        setting.preload = {};
      } else {
        setting.locales = [];
        for (var l in setting.preload) {
          setting.locales.push(l);
        }
      }

      if (!Cache.has(setting.path)) {
        Cache.set(setting.path, {
          locales: new _Set(setting.locales),
          preload: setting.preload
        });
      } else {
        (function () {
          var c = Cache.get(setting.path);
          setting.locales.forEach(function (l) {
            c.locales.add(l);
          });
          if (setting.preload) {
            for (var l in setting.preload) {
              if (!c.preload[l]) {
                c.preload[l] = setting.preload[l];
              }
            }
          }
        })();
      }
    }

    self.__proto__ = this.__proto__;
    return self;
  }

  _createClass(Locale, [{
    key: 'loadLocales',
    value: function loadLocales() {
      var mapping, locale, acceptLanguage, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _loop, _iterator, _step;

      return _regeneratorRuntime.async(function loadLocales$(context$2$0) {
        var _this = this;

        while (1) switch (context$2$0.prev = context$2$0.next) {
          case 0:
            if (!(isClient && !localeDataLoaded)) {
              context$2$0.next = 3;
              break;
            }

            context$2$0.next = 3;
            return _regeneratorRuntime.awrap(System['import']('intl/locale-data/complete'));

          case 3:
            mapping = this[_Ctx].localeMapping;
            locale = this[_Ctx].locale;
            acceptLanguage = this[_Ctx].acceptLanguage;
            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _iteratorError = undefined;
            context$2$0.prev = 9;

            _loop = function callee$2$0() {
              var _step$value, p, c, match;

              return _regeneratorRuntime.async(function callee$2$0$(context$3$0) {
                while (1) switch (context$3$0.prev = context$3$0.next) {
                  case 0:
                    _step$value = _slicedToArray(_step.value, 2);
                    p = _step$value[0];
                    c = _step$value[1];
                    match = findMatch(locale, c.locales);

                    //find a match from accepted languages current locale isn't available
                    if (!match) {
                      if (acceptLanguage.every(function (l) {
                        match = findMatch(l, c.locales);
                        return !match;
                      })) {
                        match = c.locales.entries().next().value.shift();
                      }
                    }

                    if (c.preload[match]) {
                      context$3$0.next = 13;
                      break;
                    }

                    if (!(typeof window !== 'undefined' && typeof System !== 'undefined')) {
                      context$3$0.next = 12;
                      break;
                    }

                    context$3$0.next = 9;
                    return _regeneratorRuntime.awrap(System['import'](p + '/' + match + '.json!'));

                  case 9:
                    c.preload[match] = context$3$0.sent;
                    context$3$0.next = 13;
                    break;

                  case 12:
                    c.preload[match] = require(p + '/' + match + '.json');

                  case 13:
                    mapping[p] = match;

                  case 14:
                  case 'end':
                    return context$3$0.stop();
                }
              }, null, _this);
            };

            _iterator = _getIterator(Cache);

          case 12:
            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
              context$2$0.next = 18;
              break;
            }

            context$2$0.next = 15;
            return _regeneratorRuntime.awrap(_loop());

          case 15:
            _iteratorNormalCompletion = true;
            context$2$0.next = 12;
            break;

          case 18:
            context$2$0.next = 24;
            break;

          case 20:
            context$2$0.prev = 20;
            context$2$0.t0 = context$2$0['catch'](9);
            _didIteratorError = true;
            _iteratorError = context$2$0.t0;

          case 24:
            context$2$0.prev = 24;
            context$2$0.prev = 25;

            if (!_iteratorNormalCompletion && _iterator['return']) {
              _iterator['return']();
            }

          case 27:
            context$2$0.prev = 27;

            if (!_didIteratorError) {
              context$2$0.next = 30;
              break;
            }

            throw _iteratorError;

          case 30:
            return context$2$0.finish(27);

          case 31:
            return context$2$0.finish(24);

          case 32:
          case 'end':
            return context$2$0.stop();
        }
      }, null, this, [[9, 20, 24, 32], [25,, 27, 31]]);
    }
  }, {
    key: 'setLocale',
    value: function setLocale(l) {
      var previousLocale;
      return _regeneratorRuntime.async(function setLocale$(context$2$0) {
        while (1) switch (context$2$0.prev = context$2$0.next) {
          case 0:
            previousLocale = this[_Ctx].locale;

            this[_Ctx].locale = l;
            context$2$0.prev = 2;
            context$2$0.next = 5;
            return _regeneratorRuntime.awrap(this.loadLocales());

          case 5:
            this[_Ctx].emit('locale-change');
            context$2$0.next = 14;
            break;

          case 8:
            context$2$0.prev = 8;
            context$2$0.t0 = context$2$0['catch'](2);

            this[_Ctx].locale = previousLocale;
            context$2$0.next = 13;
            return _regeneratorRuntime.awrap(this.loadLocales());

          case 13:
            this[_Ctx].emit('error', new _errors.LocaleLoadError(context$2$0.t0));

          case 14:
          case 'end':
            return context$2$0.stop();
        }
      }, null, this, [[2, 8]]);
    }
  }, {
    key: 'formatNumber',
    value: function formatNumber() {
      var locale = this[_Ctx].locale;

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return Locale.formatNumber.apply(Locale, [locale].concat(args));
    }
  }, {
    key: 'formatDateTime',
    value: function formatDateTime() {
      var locale = this[_Ctx].locale;

      for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      return Locale.formatDateTime.apply(Locale, [locale].concat(args));
    }
  }, {
    key: 'formatCurrency',
    value: function formatCurrency() {
      var locale = this[_Ctx].locale;

      for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        args[_key3] = arguments[_key3];
      }

      return Locale.formatCurrency.apply(Locale, [locale].concat(args));
    }
  }, {
    key: 'locale',
    get: function get() {
      return this[_Ctx].locale;
    }
  }], [{
    key: 'formatNumber',
    value: function formatNumber(locale, value, opts) {
      locale = locale.replace('_', '-');
      var key = locale + ':' + JSON.stringify(opts);
      if (!NumberFormatters.has(key)) {
        NumberFormatters.set(key, Intl.NumberFormat(locale, opts));
      }
      var f = NumberFormatters.get(key);
      return f.format(value);
    }
  }, {
    key: 'formatDateTime',
    value: function formatDateTime(locale, t, opts) {
      locale = locale.replace('_', '-');
      var key = locale + ':' + JSON.stringify(opts);
      if (!DateFormatters.has(key)) {
        DateFormatters.set(key, Intl.DateTimeFormat(locale, opts));
      }
      var f = DateFormatters.get(key);
      return f.format(t);
    }
  }, {
    key: 'formatCurrency',
    value: function formatCurrency(locale, value, currency, fixed) {
      currency = currency.toUpperCase();
      var opts = {
        style: 'currency',
        currency: currency.toUpperCase()
      };
      if (typeof fixed === 'number') {
        fixed = ~ ~fixed;
        opts.minimumFractionDigits = fixed;
        opts.maximumFractionDigits = fixed;
      }
      return this.formatNumber(locale, value, opts);
    }
  }]);

  return Locale;
})();

exports['default'] = Locale;

function findMatch(locale, list) {
  if (list.has(locale)) {
    return locale;
  } else {
    var ln = locale.split('-').shift();
    if (list.has(ln)) {
      //locale = zh-TW, list has zh
      return ln;
    } else {
      //locale = zh, list has zh-TW
      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = _getIterator(list), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var entry = _step2.value;

          if (entry.split('-').shift() === ln) {
            return entry;
          }
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2['return']) {
            _iterator2['return']();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }
    }
  }
}
module.exports = exports['default'];

//check if path exists in Cache
//# sourceMappingURL=locale.js.map
