'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _slicedToArray = require('babel-runtime/helpers/sliced-to-array')['default'];

var _Symbol = require('babel-runtime/core-js/symbol')['default'];

var _Map = require('babel-runtime/core-js/map')['default'];

var _getIterator = require('babel-runtime/core-js/get-iterator')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _module2 = require('module');

var _module3 = _interopRequireDefault(_module2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _url = require('url');

var _url2 = _interopRequireDefault(_url);

var _greaseboxEscapeRegExp = require('greasebox/escape-reg-exp');

var _greaseboxEscapeRegExp2 = _interopRequireDefault(_greaseboxEscapeRegExp);

var _Enabled = _Symbol();
var _OriginalRequire = _Symbol();
var _Filters = _Symbol();
var _Loaders = _Symbol();
var _FileRoot = _Symbol();
var _UrlRoot = _Symbol();
var _Version = _Symbol();

var meepworksCheck = /^meepworks\//;

var RequireFilter = (function () {
  /**
   * @constructor
   * @param {object} param {
   *    root: root absolute folder path on the server,
   *    baseURL: baseURL for the hosted application
   *    version: version string to append to output
   * }
   */

  function RequireFilter(_ref) {
    var root = _ref.root;
    var _ref$baseURL = _ref.baseURL;
    var baseURL = _ref$baseURL === undefined ? '' : _ref$baseURL;
    var version = _ref.version;

    _classCallCheck(this, RequireFilter);

    this[_Enabled] = true;
    this[_Filters] = new _Map();
    this[_Loaders] = new _Map();
    this[_OriginalRequire] = _module3['default'].prototype.require;

    //skip trailing '/'
    if (root[root.length - 1] === '/') {
      this[_FileRoot] = root.substr(0, root.length - 1);
    } else {
      this[_FileRoot] = root;
    }

    //skip trailing '/'
    if (baseURL[baseURL.length - 1] === '/') {
      this[_UrlRoot] = baseURL.substr(0, baseURL.length - 1);
    } else {
      this[_UrlRoot] = baseURL;
    }

    //prepare version string
    this[_Version] = version ? '?' + version : '';

    var instance = this;

    //don't use arrow function, cannot bind this here
    _module3['default'].prototype.require = function require(p) {
      var _this = this;

      if (instance[_Enabled]) {
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = _getIterator(instance[_Filters]), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var _step$value = _slicedToArray(_step.value, 2);

            var f = _step$value[0];
            var reg = _step$value[1];

            //f = filtername, reg = regex
            if (reg.test(p)) {
              if (instance[_Loaders].has(f)) {
                var l = instance[_Loaders].get(f);
                return l.call(this, p, function (p) {
                  p = p.split('!')[0];
                  var target = _path2['default'].resolve(_path2['default'].dirname(_this.filename), p);
                  return instance[_OriginalRequire].call(_this, target);
                });
              } else {
                p = p.split('!')[0];
                var target = _path2['default'].resolve(_path2['default'].dirname(this.filename), p);
                var relToRoot = _path2['default'].relative(instance[_FileRoot], target);
                return instance[_UrlRoot] + '/' + relToRoot + instance[_Version];
              }
            }
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator['return']) {
              _iterator['return']();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
      }
      return instance[_OriginalRequire].call(this, p);
    };
  }

  _createClass(RequireFilter, [{
    key: 'filter',
    value: function filter(f, loader) {
      if (!this[_Filters].has(f)) {
        if (f instanceof RegExp) {
          this[_Filters].set(f, f);
        } else {
          this[_Filters].set(f, new RegExp(asterickToAny((0, _greaseboxEscapeRegExp2['default'])(f)) + '$', 'i'));
        }
        if (typeof loader === 'function') {
          this[_Loaders].set(f, loader);
        }
      }
    }
  }, {
    key: 'removeFilter',
    value: function removeFilter(f) {
      if (this[_Filters].has(f)) {
        this[_Filters]['delete'](f);
        if (this[_Loaders].has(f)) {
          this[_Loaders]['delete'](f);
        }
      }
    }
  }, {
    key: 'enable',
    value: function enable() {
      this[_Enabled] = true;
    }
  }, {
    key: 'disable',
    value: function disable() {
      this[_Enabled] = false;
    }
  }, {
    key: 'isEnabled',
    get: function get() {
      return this[_Enabled];
    }
  }]);

  return RequireFilter;
})();

exports['default'] = RequireFilter;

function asterickToAny(str) {
  return str.replace(/\\\*/g, '.*');
}
module.exports = exports['default'];
//# sourceMappingURL=require-filter.js.map
