'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _regeneratorRuntime = require('babel-runtime/regenerator')['default'];

var _Symbol = require('babel-runtime/core-js/symbol')['default'];

var _Map = require('babel-runtime/core-js/map')['default'];

var _Promise = require('babel-runtime/core-js/promise')['default'];

var _Set = require('babel-runtime/core-js/set')['default'];

var _getIterator = require('babel-runtime/core-js/get-iterator')['default'];

var _Object$keys = require('babel-runtime/core-js/object/keys')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});
var marked0$0 = [clientRenderer, serverRenderer].map(_regeneratorRuntime.mark);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _componentEmitter = require('component-emitter');

var _componentEmitter2 = _interopRequireDefault(_componentEmitter);

var _historyLibCreateLocation = require('history/lib/createLocation');

var _historyLibCreateLocation2 = _interopRequireDefault(_historyLibCreateLocation);

var _reactRouter = require('react-router');

var _reactDomServer = require('react-dom/server');

var _systemjsBuilder = require('systemjs-builder');

var _systemjsBuilder2 = _interopRequireDefault(_systemjsBuilder);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _htmlPage = require('./html-page');

var _htmlPage2 = _interopRequireDefault(_htmlPage);

var _tmpl = require('./tmpl');

var _tmpl2 = _interopRequireDefault(_tmpl);

var _applicationContext = require('./application-context');

var _applicationContext2 = _interopRequireDefault(_applicationContext);

var _bootstrap = require('./bootstrap');

var _bootstrap2 = _interopRequireDefault(_bootstrap);

var _url = require('url');

var _url2 = _interopRequireDefault(_url);

var doctype = '<!DOCTYPE html>';

var _ErrorTransport = _Symbol();
var CssCache = new _Map();

var ServerRouter = (function () {
  function ServerRouter(_ref) {
    var _this = this;

    var appPath = _ref.appPath;
    var _ref$publicPath = _ref.publicPath;
    var publicPath = _ref$publicPath === undefined ? '/' : _ref$publicPath;
    var _ref$publicUrl = _ref.publicUrl;
    var publicUrl = _ref$publicUrl === undefined ? '' : _ref$publicUrl;
    var _ref$jspmPath = _ref.jspmPath;
    var jspmPath = _ref$jspmPath === undefined ? 'jspm_packages' : _ref$jspmPath;
    var _ref$jspmConfig = _ref.jspmConfig;
    var jspmConfig = _ref$jspmConfig === undefined ? 'jspm_packages/config.js' : _ref$jspmConfig;
    var version = _ref.version;
    var _ref$preloadCss = _ref.preloadCss;
    var preloadCss = _ref$preloadCss === undefined ? true : _ref$preloadCss;
    var root = _ref.root;
    var _ref$clientRender = _ref.clientRender;
    var clientRender = _ref$clientRender === undefined ? false : _ref$clientRender;
    var loadingComponent = _ref.loadingComponent;

    _classCallCheck(this, ServerRouter);

    this.appPath = appPath;
    this.publicPath = publicPath;
    this.publicUrl = publicUrl;
    this.version = version;
    this.jspmPath = jspmPath;
    this.jspmConfig = jspmConfig;
    this.preloadCss = preloadCss !== false;
    this.root = root;
    this.clientRender = !!clientRender;
    this.loadingComponent = loadingComponent;

    this[_ErrorTransport] = function (err) {
      _this.emit('error', err);
    };
  }

  _createClass(ServerRouter, [{
    key: 'routes',
    get: function get() {
      var router = this;
      //let appPath = path.resolve( router.dirname, router.app );
      var App = require(router.appPath);

      return _regeneratorRuntime.mark(function callee$2$0(next) {
        return _regeneratorRuntime.wrap(function callee$2$0$(context$3$0) {
          while (1) switch (context$3$0.prev = context$3$0.next) {
            case 0:
              if (!router.clientRender) {
                context$3$0.next = 5;
                break;
              }

              context$3$0.next = 3;
              return clientRenderer.call(this, router, App);

            case 3:
              context$3$0.next = 7;
              break;

            case 5:
              context$3$0.next = 7;
              return serverRenderer.call(this, router, App);

            case 7:
            case 'end':
              return context$3$0.stop();
          }
        }, callee$2$0, this);
      });
    }
  }]);

  return ServerRouter;
})();

exports['default'] = ServerRouter;

(0, _componentEmitter2['default'])(ServerRouter.prototype);

/* Html boyd renderer for rendering content on client side */
function clientRenderer(router, App) {
  var acceptLanguage, locale, ctx, data, loader, styles, Loader;
  return _regeneratorRuntime.wrap(function clientRenderer$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        acceptLanguage = this.get('accept-language');

        if (acceptLanguage) {
          acceptLanguage = acceptLanguage.split(',').map(function (l) {
            return normalizeLocaleCode(l.split(';').shift());
          });
        } else {
          acceptLanguage = [];
        }
        if (acceptLanguage.length === 0) {
          acceptLanguage.push(router.defaultLocale);
        }
        locale = acceptLanguage[0];
        ctx = new _applicationContext2['default']({
          locale: locale,
          acceptLanguage: acceptLanguage,
          initialData: this.initialData
        });
        data = {
          storeData: [],
          acceptLanguage: ctx.acceptLanguage,
          locale: ctx.locale,
          localeMapping: ctx.localeMapping,
          initialData: ctx.initialData
        };
        loader = undefined;
        styles = [];

        if (!router.loadingComponent) {
          context$1$0.next = 15;
          break;
        }

        Loader = require(router.loadingComponent);

        loader = _react2['default'].createElement(Loader, null);

        if (CssCache.has(router.loadingComponent)) {
          context$1$0.next = 14;
          break;
        }

        context$1$0.next = 14;
        return traceCss.call(router, router.loadingComponent);

      case 14:
        CssCache.get(router.loadingComponent).forEach(function (css, idx) {
          styles.push(_react2['default'].createElement('link', { key: 'css:' + idx, rel: 'stylesheet', href: css }));
        });

      case 15:

        this.body = doctype + (0, _reactDomServer.renderToStaticMarkup)(_react2['default'].createElement(
          _htmlPage2['default'],
          {
            scripts: [_bootstrap2['default'].call(router, data)],
            styles: styles
          },
          loader
        ));

      case 16:
      case 'end':
        return context$1$0.stop();
    }
  }, marked0$0[0], this);
}

/* Html body renderer for rendering content on server side */
function serverRenderer(router, App) {
  var location, acceptLanguage, locale, ctx;
  return _regeneratorRuntime.wrap(function serverRenderer$(context$1$0) {
    var _this3 = this;

    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        location = (0, _historyLibCreateLocation2['default'])(this.req.url);
        acceptLanguage = this.get('accept-language');

        if (acceptLanguage) {
          acceptLanguage = acceptLanguage.split(',').map(function (l) {
            return normalizeLocaleCode(l.split(';').shift());
          });
        } else {
          acceptLanguage = [];
        }
        if (acceptLanguage.length === 0) {
          acceptLanguage.push(router.defaultLocale);
        }
        locale = acceptLanguage[0];
        ctx = new _applicationContext2['default']({
          locale: locale,
          acceptLanguage: acceptLanguage,
          initialData: this.initialData
        });

        ctx.files.add(router.appPath);
        ctx.init = true;
        ctx.on('error', router[_ErrorTransport]);

        context$1$0.next = 11;
        return new _Promise(function (resolve) {

          (0, _reactRouter.match)({ routes: new App(ctx).routes, location: location }, function callee$2$0(error, redirectLocation, renderProps) {
            var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step;

            return _regeneratorRuntime.async(function callee$2$0$(context$3$0) {
              var _this2 = this;

              while (1) switch (context$3$0.prev = context$3$0.next) {
                case 0:
                  if (redirectLocation) {
                    this.redirect(redirectLocation.pathname + redirectLocation.search);
                  } else if (error) {
                    this.status = 500;
                    router.emit('error', error);
                  }

                  if (!renderProps) {
                    context$3$0.next = 11;
                    break;
                  }

                  context$3$0.prev = 2;
                  context$3$0.next = 5;
                  return _regeneratorRuntime.awrap((function callee$3$0() {
                    var title, data, cssPreloads, src, styles;
                    return _regeneratorRuntime.async(function callee$3$0$(context$4$0) {
                      while (1) switch (context$4$0.prev = context$4$0.next) {
                        case 0:
                          title = ctx.title;

                          if (title) {
                            title = _tmpl2['default'].format(title, this.params);
                          }
                          data = {
                            storeData: [],
                            acceptLanguage: ctx.acceptLanguage,
                            locale: ctx.locale,
                            localeMapping: ctx.localeMapping,
                            initialData: ctx.initialData
                          };

                          ctx.stores.forEach(function (s) {
                            data.storeData.push(s.dehydrate());
                          });

                          cssPreloads = new _Set();

                          //trace files for imported css files
                          _iteratorNormalCompletion = true;
                          _didIteratorError = false;
                          _iteratorError = undefined;
                          context$4$0.prev = 8;
                          _iterator = _getIterator(ctx.files);

                        case 10:
                          if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                            context$4$0.next = 23;
                            break;
                          }

                          src = _step.value;

                          if (CssCache.has(src)) {
                            context$4$0.next = 19;
                            break;
                          }

                          if (!router.preloadCss) {
                            context$4$0.next = 18;
                            break;
                          }

                          context$4$0.next = 16;
                          return _regeneratorRuntime.awrap(traceCss.call(router, src));

                        case 16:
                          context$4$0.next = 19;
                          break;

                        case 18:
                          traceCss.call(router, src);

                        case 19:
                          if (CssCache.has(src)) {
                            CssCache.get(src).forEach(function (css) {
                              cssPreloads.add(css);
                            });
                          }

                        case 20:
                          _iteratorNormalCompletion = true;
                          context$4$0.next = 10;
                          break;

                        case 23:
                          context$4$0.next = 29;
                          break;

                        case 25:
                          context$4$0.prev = 25;
                          context$4$0.t0 = context$4$0['catch'](8);
                          _didIteratorError = true;
                          _iteratorError = context$4$0.t0;

                        case 29:
                          context$4$0.prev = 29;
                          context$4$0.prev = 30;

                          if (!_iteratorNormalCompletion && _iterator['return']) {
                            _iterator['return']();
                          }

                        case 32:
                          context$4$0.prev = 32;

                          if (!_didIteratorError) {
                            context$4$0.next = 35;
                            break;
                          }

                          throw _iteratorError;

                        case 35:
                          return context$4$0.finish(32);

                        case 36:
                          return context$4$0.finish(29);

                        case 37:
                          styles = [];

                          cssPreloads.forEach(function (css, idx) {
                            styles.push(_react2['default'].createElement('link', { key: 'css:' + idx, rel: 'stylesheet', href: css }));
                          });

                          this.body = doctype + (0, _reactDomServer.renderToStaticMarkup)(_react2['default'].createElement(
                            _htmlPage2['default'],
                            {
                              title: title,
                              scripts: [_bootstrap2['default'].call(router, data)],
                              styles: styles
                            },
                            _react2['default'].createElement(_reactRouter.RoutingContext, renderProps)
                          ));

                        case 40:
                        case 'end':
                          return context$4$0.stop();
                      }
                    }, null, _this2, [[8, 25, 29, 37], [30,, 32, 36]]);
                  })());

                case 5:
                  context$3$0.next = 11;
                  break;

                case 7:
                  context$3$0.prev = 7;
                  context$3$0.t0 = context$3$0['catch'](2);

                  this.status = 500;
                  router.emit('error', context$3$0.t0);

                case 11:
                  ctx.off('error', router[_ErrorTransport]);
                  resolve();

                case 13:
                case 'end':
                  return context$3$0.stop();
              }
            }, null, _this3, [[2, 7]]);
          });
        });

      case 11:
      case 'end':
        return context$1$0.stop();
    }
  }, marked0$0[1], this);
}

function normalizeLocaleCode(code) {
  code = code.replace('-', '_');
  code = code.split('_');
  code[0] = code[0].toLowerCase();
  if (code.length > 1) {
    code[1] = code[1].toUpperCase();
  }
  return code.join('_');
}

var cssCheck = /\.css$/i;

function traceCss(appPath) {
  return _regeneratorRuntime.async(function traceCss$(context$1$0) {
    var _this5 = this;

    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        context$1$0.prev = 0;
        context$1$0.next = 3;
        return _regeneratorRuntime.awrap((function callee$1$0() {
          var builder, trace, preloads;
          return _regeneratorRuntime.async(function callee$1$0$(context$2$0) {
            var _this4 = this;

            while (1) switch (context$2$0.prev = context$2$0.next) {
              case 0:
                builder = new _systemjsBuilder2['default'](this.root, this.jspmConfig);
                context$2$0.next = 3;
                return _regeneratorRuntime.awrap(builder.trace(appPath));

              case 3:
                trace = context$2$0.sent;
                preloads = _Object$keys(trace).filter(function (item) {
                  return cssCheck.test(trace[item].path);
                }).map(function (item) {

                  var p = trace[item].path;
                  if (p.indexOf(_this4.jspmPath) > -1) {
                    return '/' + p;
                  } else {
                    return '/' + _path2['default'].resolve(p).replace(_this4.publicPath, _this4.publicUrl) + (_this4.version ? '?' + _this4.version : '');
                  }
                });

                builder.reset();
                CssCache.set(appPath, preloads);

              case 7:
              case 'end':
                return context$2$0.stop();
            }
          }, null, _this5);
        })());

      case 3:
        context$1$0.next = 8;
        break;

      case 5:
        context$1$0.prev = 5;
        context$1$0.t0 = context$1$0['catch'](0);

        console.log(context$1$0.t0, context$1$0.t0.stack);

      case 8:
      case 'end':
        return context$1$0.stop();
    }
  }, null, this, [[0, 5]]);
}
module.exports = exports['default'];

//process locale list from browser

//await builder.loadConfig(this.jspmConfig);
//# sourceMappingURL=server-router.js.map
