/**
 *  @exports default
 *  @class StyleMap - Represents a map of style definations.
 */
'use strict';

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var Styles =
/**
 *  @constructor
 *  @param {Object} map - A map of style definitions.
 */
function Styles(map) {
  _classCallCheck(this, Styles);

  for (var name in map) {
    if (typeof map[name] === 'object') {
      this[name] = new Style(map[name]);
    }
  }
}

/**
 * @class Style - Represent a style definination.
 */
;

exports['default'] = Styles;

var Style =
/**
 * @constructor
 * @param {Object} def - The css style definition in object literal form.
 */
function Style(def) {
  _classCallCheck(this, Style);

  traverseDefinition.call(this, def);
};

function traverseDefinition(def) {
  for (var prop in def) {
    if (typeof def[prop] === 'object') {
      //Any nested object should be treated as style definitions returned by
      //functions, and merged into this definition.
      traverseDefinition.call(this, def[prop]);
    } else {
      this[prop] = def[prop];
    }
  }
}
module.exports = exports['default'];
//# sourceMappingURL=styles.js.map
