'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _greaseboxEscapeRegExp = require('greasebox/escape-reg-exp');

var _greaseboxEscapeRegExp2 = _interopRequireDefault(_greaseboxEscapeRegExp);

/**
 * @exports default
 * @class Tmpl
 */

var Tmpl = (function () {
  /**
   * @constructor
   * @param {String} tmpl - the template string
   */

  function Tmpl(tmpl) {
    _classCallCheck(this, Tmpl);

    this.tmpl = tmpl;
  }

  /**
   * @static
   * @function
   * @param {String} tmpl - the template string
   * @param {Object} map - the variable map for template
   * @return {String} - return the formatted string using tmpl and params.
   *                  - return empty string if tmpl is not a string.
   */

  _createClass(Tmpl, [{
    key: 'format',

    /**
     * @function
     * @param {Object} params - the variable map for the template.
     * @return {String} - return the result of Tmpl.format using this.tmpl and params.
     */
    value: function format(params) {
      return Tmpl.format(this.tmpl, params);
    }
  }], [{
    key: 'format',
    value: function format(tmpl, params) {
      if (typeof tmpl !== 'string') {
        return '';
      }
      var res = tmpl;
      if (params) {
        for (var p in params) {
          var reg = new RegExp('\\$\\{' + (0, _greaseboxEscapeRegExp2['default'])(p) + '\\}', 'g');
          res = res.replace(reg, params[p]);
        }
      }
      return res;
    }
  }]);

  return Tmpl;
})();

exports['default'] = Tmpl;
module.exports = exports['default'];
//# sourceMappingURL=tmpl.js.map
